<template>	
  <div class="text-center">
    <h3 class="text-primary">Verify Your Data</h3>
    <p>Make any needed changes below</p>
  </div>

  <div class="row m-3">
    <div class="col-md-4 mb-3">
      <label class="form-label">WSU ID</label>
      <small class="text-body-secondary">Brief description</small>
      <input class="form-control" :value="studentData.wsuID" disabled />
    </div>

    <div class="col-md-4 mb-3">
      <label class="form-label">Age</label>
      <input class="form-control" :value="studentData.guestAge" disabled />
    </div>

    <div class="col-md-4 mb-3">
      <label class="form-label">Zip Code</label>
      <input class="form-control" :value="studentData.zipCode" disabled />
    </div>

    <div class="col-md-4 mb-3">
      <label class="form-label">Campus Resident</label>
      <input class="form-control" :value="studentData.resident? 'Yes' : 'No'" disabled />
    </div>

    <div class="col-md-4 mb-3">
      <label class="form-label">Number in household</label>
      <input class="form-control" :value="studentData.numberInHousehold" disabled />
    </div>

    <div class="col-md-4 mb-3">
      <label class="form-label">Unemployed</label>
      <input class="form-control" :value="studentData.unemployment? 'Yes' : 'No'" disabled />
    </div>

    <h4 class="form-label mt-3 text-center text-success">Assistance</h4>
    <div v-for="status in Object.keys(studentData.assistance)" :key="status" class="col-md-4 mb-3">
      <label class="form-label d-inline-block text-truncate" style="max-width: 100%;">{{ assistanceNames[status] }}</label>
      <input class="form-control" :value="studentData.assistance[status] ? 'Yes' : 'No'" disabled />
    </div>
		

    <!-- Modal -->
    <div id="guestInfoModal" class="modal fade" tabindex="-1" aria-labelledby="editModalLabel" aria-hidden="true" data-bs-backdrop="static">
      <div class="modal-dialog">
        <div class="modal-content">
          <div class="modal-header">
            <h1 id="editModalLabel" class="modal-title fs-5">Edit student information</h1>
            <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close" />
          </div>
          <div class="modal-body">
            <GuestInfoComponent :student-data="studentData" :existing-guest="existingGuest" />
          </div>
          <div class="modal-footer">
            <button type="button" class="btn btn-secondary" data-bs-dismiss="modal" @click="cancelUpdate">Close</button>
            <button type="button" class="btn btn-primary" data-bs-dismiss="modal" @click="makeChanges()">Save changes</button>
          </div>
        </div>
      </div>
    </div>

			
    <div class="container">
      <div class="row mt-4 mb-3">
        <div class="col-5 mx-auto">
          <button class="w-100 btn btn-primary btn-lg" type="button" data-bs-toggle="modal" data-bs-target="#guestInfoModal" @click="toggleEdit">Edit</button>
          <!-- <button @click="makeChanges()" v-else class="w-100 btn btn-primary btn-lg" type="button">Save</button> -->
        </div>

        <div class="col-5 mx-auto">
          <button class="w-100 btn btn-warning btn-lg" type="button" @click="goHome">Proceed</button>
          <!-- <button @click="cancelUpdate" v-else  class="w-100 btn btn-danger btn-lg" type="button">Close</button> -->
        </div>
      </div>
    </div>
  </div>
</template>

<script>

import { databaseWarehouse } from '../stores/wsuStudentStore'

import GuestInfoComponent from '../components/GuestInfoComponent.vue'

	export default {
		components: {
			GuestInfoComponent
		},
		data() {
			return {
				studentData: {
					// eslint-disable-next-line vue/no-computed-properties-in-data
					wsuID: this.studentID,
					resident: false,
					zipCode: '',
					unemployment: false,
					assistance: {
						socSec: false,
						TANF: false,
						finAid: false,
						other: false,
						SNAP: false,
						WIC: false,
						breakfast: false,
						lunch: false,
						SFSP: false
					},
					guestAge: 0,
					numberInHousehold: 0
				},
				existingGuest: false
			}
		},
		computed: {
			// computed helps us to get results after an operation has been performed
			// heavy operations are performed ahead of time so we don't have to wait or waste time and resources loading data
			studentID() {
				return databaseWarehouse().guestData.wsuID
			},
			assistanceNames() {
				// Map boolean values to real-world names
				return {
					socSec: 'Social Security',
					TANF: 'TANF - Temporary Assistance for Needy Families',
					finAid: 'Financial Aid',
					other: 'Other Assistance',
					SNAP: 'SNAP - Supplemental Nutrition Assistance Program',
					WIC: 'WIC - Women, Infants, and Children Program',
					breakfast: 'Breakfast Assistance',
					lunch: 'Lunch Assistance',
					SFSP: 'SFSP - Summer Food Service Program',
				}
			}
		},
		async mounted() {
			// scroll to the top of the component when page is loaded
			window.scrollTo(0,0)

			await this.initializeData()
		},
		methods: {
			async initializeData() {
				await databaseWarehouse().getGuestData(this.studentID).then((data) => {
					this.existingGuest = databaseWarehouse().existingGuest
					this.studentData = Object.assign({}, data)
				})
			},
			goHome() {
				databaseWarehouse().$reset()
				alert('Proceed into the pantry')
				this.$router.push('/')
			},
			async makeChanges() {
				try {
					const data = await databaseWarehouse().updateGuestData(this.studentData)
					// console.log(data) - returns true or false

					// After successfully updating user data show disabled form
					if(data) {
						this.toggleEdit()
					}
					else {
						this.initializeData()
					}
					
				} catch (error) {
					console.error('Error updating data:', error)
				}
			},
			toggleEdit() {
			
			},
			cancelUpdate() {
				this.initializeData()
			}
		}
	}
</script>

<style scoped>
</style>
